<template>
  <section class="c-role-cv">
    <Title
      :text="data.your_cv_title"
      type="secondary"
      :requiredSign="!isPreview"
    />
    <div v-show="!isPreview">
      <Paragraph :text="data.your_cv_text" />
      <FormRadio
        id="cv"
        :options="options"
        v-model="fields.cvCondition.$model"
        :error="formErrorMessagesHandler(fields.cvCondition)"
      />
      <div v-if="fields.cvCondition.$model === 'no'" class="b-upload">
        <Paragraph class="b-upload__p" :text="data.your_cv_description" />
        <FormControl
          id="cvUpload"
          label="Your CV"
          :required="true"
          class="label-left"
          :error="handleFileErrors()"
        >
          <div class="c-upload">
            <div class="c-upload__name">
              {{ fileState.name ? fileState.name : "Upload your CV" }}
            </div>
            <label for="cv-upload" class="c-upload__button">
              Browse
              <input
                id="cv-upload"
                type="file"
                ref="file"
                @change="handleFileUpload()"
                :accept="fileState.accept"
              />
            </label>
          </div>
        </FormControl>
        <span class="b-upload__limit">
          Max upload 5mb, allowed filetypes PDF and Word
        </span>
      </div>
    </div>

    <div v-if="isPreview">
      <Paragraph
        v-if="fields.cvCondition.$model === 'no'"
        :text="fileState.name"
      />
      <div v-else>
        <Paragraph :text="data.your_cv_text" />
        <Paragraph
          :text="fields.cvCondition.$model.toUpperCase()"
          weight="semibold"
        />
      </div>
    </div>
  </section>
</template>

<script>
import Title from "../ui/Title";
import { validationMixin } from "vuelidate";
import { mapMutations } from "vuex";
import { errorMixins } from "../mixins/formErrors";
import Paragraph from "../ui/Paragraph";
import FormRadio from "../ui/form/FormRadio";
import FormControl from "../ui/form/FormControl";
import { isPreviewMixin } from "../mixins/isPreview";

export default {
  name: "RoleCV",
  components: {
    FormRadio,
    Paragraph,
    Title,
    FormControl
  },
  props: {
    fields: {
      type: Object,
      required: true
    }
  },
  mixins: [validationMixin, errorMixins, isPreviewMixin],
  data: function() {
    return {
      data: this.$store.state.data.data.your_cv,
      options: [
        {
          label: "Yes",
          value: "yes"
        },
        {
          label: "No",
          value: "no"
        }
      ],
      fileState: {
        name: "",
        allowedSize: 5,
        error: "",
        accept: ".pdf, .doc, .docx"
      }
    };
  },
  methods: {
    ...mapMutations(["addCvFile", "removeCvFile"]),
    handleFileErrors() {
      if (this.fileState.error && !this.fields.cvFile.$model) {
        return this.fileState.error;
      }

      return this.formErrorMessagesHandler(this.fields.cvFile);
    },
    handleFileUpload() {
      const file = this.$refs.file.files[0];

      if (file) {
        const fileSizeMB = file.size / (1024 * 1024);

        if (fileSizeMB > 5) {
          this.fileState.error = `The file is bigger than ${this.fileState.allowedSize}mb`;
          this.$store.commit("removeCvFile");
        } else {
          this.fileState.error = "";
          this.fileState.name = file.name;
          this.$store.commit("addCvFile", file);
        }
      }
    }
  }
};
</script>

<style lang="scss">
.c-role-cv {
  display: inline-block;
  width: 100%;
  margin-bottom: 4rem;
}

.b-upload {
  &__p {
    margin-top: 3rem;
  }
  &__limit {
    display: block;
    font-size: 1.4rem;
    line-height: 2.4rem;
    color: $c-gray-secondary;
    margin-top: 3rem;
  }
}

.c-upload {
  display: flex;
  align-items: center;
  height: 5rem;
  width: 100%;
  @include breakpoint(overPhone) {
    height: 4.1rem;
    max-width: 34rem;
  }
  &__name {
    display: flex;
    align-items: center;
    height: 100%;
    width: 62%;
    border: 1px solid $c-gray-quaternary;
    border-right: none;
    padding: 0 1rem;
    @include truncate-text;
    font-size: 1.6rem;
    color: $c-gray-secondary;
  }
  &__button {
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    height: 100%;
    width: 38%;
    background-color: $c-brand-primary;
    color: $c-white;
    cursor: pointer;
    font-size: 1.6rem;

    input {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      z-index: 1;
      opacity: 0;
      visibility: hidden;
      cursor: pointer;
    }
  }
}
</style>
